/* Qt Creator 4.1.0 Based on Qt 5.7.0 (GCC 4.9.1 20140922 (Red Hat 4.9.1-10), 64 bit)  */

#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QCameraViewfinder>
#include <QCameraInfo>
#include <QTimer>
#include <QtDebug>
#include <QLayout>
#include <QGraphicsScene>
#include <QGraphicsView>
#include <QGraphicsRectItem>
#include <QWebEngineView>


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);


//    QWebEngineView *view = new QWebEngineView(parent);
//    view->load(QUrl("http://192.168.1.48:8080"));
//    view->setZoomFactor(0.4);
//    view->show();


    ui->groupBox_2->setEnabled( false );
    ui->spinBox->setValue(4);
    on_clear_memory_clicked();

    QCamera *camera=new QCamera(this);
    viewfinder = new QCameraViewfinder(this);
    viewfinder->setSizePolicy(QSizePolicy::Maximum,QSizePolicy::Maximum);
    camera->setViewfinder(viewfinder);

    QVBoxLayout *layout = new QVBoxLayout;;
    layout->addWidget(viewfinder);
    ui->frame->setLayout(layout);

    viewfinder->show();
    camera->start(); // to start the viewfinder
    camera->setViewfinder(viewfinder);

    scene = new QGraphicsScene(this);   //created a QGraphicsScene object, scene
    ui->graphicsView->setScene(scene);  //put the scene to graphicsView
    scene->setBackgroundBrush(QBrush(Qt::black));

    scene_2 = new QGraphicsScene(this);
    ui->graphicsView_2->setScene(scene_2);
    scene_2->setBackgroundBrush(QBrush(Qt::black));

    scene_3 = new QGraphicsScene(this);
    ui->graphicsView_3->setScene(scene_3);
    scene_3->setBackgroundBrush(QBrush(Qt::black));

    scene_4 = new QGraphicsScene(this);     //created a QGraphicsScene object, scene
    ui->graphicsView_4->setScene(scene_4);  //put the scene to graphicsView
    scene_4->setBackgroundBrush(QBrush(Qt::black));

    outlinePen_red.setColor(Qt::red);
    outlinePen_red.setWidth(2);
    outlinePen_black.setColor(Qt::black);
    outlinePen_black.setWidth(2);
    outlinePen_green.setColor(Qt::green);
    outlinePen_green.setWidth(2);
    outlinePen_blue.setColor(Qt::blue);
    outlinePen_blue.setWidth(2);
    outlinePen_cursor.setColor(Qt::red);
    outlinePen_cursor.setWidth(5);


    style_statusBar = "background-color: rgb(%1, %2, %3);";
    ui->guest_label->setStyleSheet( "QLabel { background-color : red; Black : White; }" );

    ui->set_x1->setMaximum( ui->graphicsView_2->width() );
    ui->set_x2->setMaximum( ui->graphicsView_2->width() );
    ui->set_y1->setMaximum( ui->graphicsView_2->height() );
    ui->set_y2->setMaximum( ui->graphicsView_2->height() );

    ui->statusBar->addPermanentWidget( ui->tcp_label, 0 );
    ui->tcp_label->setText("<font color='red'>Disconnected...</font>");

}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::doConnect()
{
    socket = new QTcpSocket(this);

    connect(socket, SIGNAL(connected()),this, SLOT(connected()));
    connect(socket, SIGNAL(disconnected()),this, SLOT(disconnected()));
//    connect(socket, SIGNAL(bytesWritten(qint64)),this, SLOT(bytesWritten(qint64)));
//    connect(socket, SIGNAL(readyRead()),this, SLOT(readyRead()));


    ui->tcp_label->setText ("<font color='green'>connecting...</font>");

    // this is not blocking call

   // socket->connectToHost( ui->ip_address->text(), 8899 );
    socket->connectToHost( "192.168.1.23", 8899 );
    // we need to wait...
    if(!socket->waitForConnected(1000))
    {
        ui->tcp_label->setText("<font color='red'>"+socket->errorString()+"</font>");
        //ui->connect_tcp->setChecked( false );
        //tcp_connect = false;
    }
}

void MainWindow::connected()
{
   ui->tcp_label->setText ("<font color='green'>Connected</font>");
   tcp_connect = true;
}

void MainWindow::disconnected()
{
    //ui->send_tcp->setEnabled( false );
    //ui->connect_tcp->setChecked( false );
    socket->close();
    ui->tcp_label->setText ("<font color='red'>Disconnected...</font>");
    tcp_connect = false;
}

void MainWindow::get_image_from_frame( uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2 ){
    uint32_t bufor_red = 0, bufor_green = 0, bufor_blue = 0, counter = 0;
    xmax = 0, ymax = 0;    //detect object
    xmin = ui->graphicsView_3->width();
    ymin = ui->graphicsView_3->height();
    black_pixel_count = 0, white_pixel_count = 0;

    if ( x1 > x2 or y1 > y2 or y1 > ui->graphicsView_3->width() or y2 > ui->graphicsView_3->height() ) return;
    scene->addRect( x1, y1, x2-x1, y2-y1, outlinePen_red);  //draw frame in QGraphicsView
    image_3 = QImage( 2 * ( x2 - x1 ) + 2, 2 * ( y2 - y1 ) + 2, QImage::Format_RGB32 );

    for (uint16_t dx = x1; dx<=x2; dx++){
    for (uint16_t dy = y1; dy<=y2; dy++){
        rgb_real = pixmap_1.toImage().pixelColor( dx, dy);   //get color from ( dx; dy ) position
        rgb_current.setRgb( rgb_real.red(), rgb_real.green(), rgb_real.blue() );
        //put here if(...) to FILTR pixel np. mono etc.
        /******************************************** Edit image [begin] *****************************************/
        if ( ui->RGB_edit->isChecked() and ui->real_filtr->isChecked() )        rgb_correct( rgb_current );
        if ( ui->black_and_white->isChecked() and ui->real_filtr->isChecked() ) rgb_mono( rgb_current );
        if ( ui->thresholding->isChecked() and ui->real_filtr->isChecked() )    thresholding( rgb_current );
        if ( ui->brightness->isChecked() and ui->real_filtr->isChecked() )      brightness( rgb_current );
        if ( ui->lut->isChecked() and ui->real_filtr->isChecked() )             lut( rgb_current );
        if ( ui->detect_object->isChecked() and ui->real_filtr->isChecked() )   detect_object( rgb_current, dx-x1, dy-y1 );
        /******************************************** Edit image [end] *******************************************/

        draw_zoom_pixel( dx - x1, dy - y1, rgb_current );

        bufor_red   = bufor_red   + rgb_current.red();
        bufor_green = bufor_green + rgb_current.green();
        bufor_blue  = bufor_blue  + rgb_current.blue();



        counter++;
    }
    }


    /************************************************ Detect ************************************************/
    if ( ui->detect_object->isChecked() and ui->real_filtr->isChecked() )  {
        detected_gesture = 0;
        finger_detect();
        fist_detect();
        thumb_rotate_detect();
        display_info_detection();
    }
    /********************************************************************************************************/

    bufor_red   = bufor_red   / counter;
    bufor_green = bufor_green / counter;
    bufor_blue  = bufor_blue  / counter;

    rgb_current.setRgb( bufor_red, bufor_green, bufor_blue );
    ui->label_temp_rgb->setText( "R: " + QString::number(rgb_current.red()) + "          G:" + QString::number(rgb_current.green()) + "            B:" + QString::number(rgb_current.blue())  );
    ui->statusBar->setStyleSheet(style_statusBar.arg(rgb_current.red()).arg(rgb_current.green()).arg(rgb_current.blue()));

    switch ( detected_gesture){
    case 0: ui->guest_label->setText("none");
        break;
    case 1: ui->guest_label->setText("close");
        break;
    case 2: ui->guest_label->setText("open");
        break;
    case 3: ui->guest_label->setText("stop");
        break;
    case 4: ui->guest_label->setText("right");
        break;
    case 5: ui->guest_label->setText("left");
        break;
    }

}

void MainWindow::send_to_array( QColor rgb_temp )
{
    for ( uint16_t x = 0; x < array_size-1 ; x++ ){
       red_array[x] = red_array[x+1];
       green_array[x] = green_array[x+1];
       blue_array[x] = blue_array[x+1];
     }

    red_array[array_size-1] = rgb_temp.red();
    green_array[array_size-1] = rgb_temp.green();
    blue_array[array_size-1] = rgb_temp.blue();
}

void MainWindow::draw_char( uint8_t red_array[], uint8_t green_array[], uint8_t blue_array[] )
{
    scene_2->clear();
          for ( uint16_t i = 0; i < array_size-1 ; i++ ){
            outlinePen_red.setWidth(1);
            outlinePen_red.setStyle(Qt::DotLine);
            scene_2->addLine( scale*i, 0, scale*(i+1), 0, outlinePen_red);          //red axix marker
            scene_2->addLine( scale*i, 53, scale*(i+1), 53, outlinePen_red);        //red axix marker
            outlinePen_red.setWidth(2);
            outlinePen_red.setStyle(Qt::SolidLine);

            outlinePen_green.setWidth(1);
            outlinePen_green.setStyle(Qt::DotLine);
            scene_2->addLine( scale*i, 60, scale*(i+1), 60, outlinePen_green);      //red axix marker
            scene_2->addLine( scale*i, 111, scale*(i+1), 111, outlinePen_green);    //red axix marker
            outlinePen_green.setWidth(2);
            outlinePen_green.setStyle(Qt::SolidLine);

            outlinePen_blue.setWidth(1);
            outlinePen_blue.setStyle(Qt::DotLine);
            scene_2->addLine( scale*i, 120, scale*(i+1), 120, outlinePen_blue);     //red axix marker
            scene_2->addLine( scale*i, 171, scale*(i+1), 171, outlinePen_blue);     //red axix marker
            outlinePen_blue.setWidth(2);
            outlinePen_blue.setStyle(Qt::SolidLine);

            scene_2->addLine( scale*i, (255-red_array[i])/5+2, scale*(i+1), (255-red_array[i+1])/5+2, outlinePen_red);
            scene_2->addLine( scale*i, (255-green_array[i])/5+60, scale*(i+1), (255-green_array[i+1])/5+60, outlinePen_green);
            scene_2->addLine( scale*i, (255-blue_array[i])/5+120, scale*(i+1), (255-blue_array[i+1])/5+120, outlinePen_blue);


          }
}

void MainWindow::draw_zoom_pixel( uint16_t x, uint16_t y, QColor rgb_temp )
{
    image_3.setPixelColor( 2*x,     2*y,    rgb_temp );
    image_3.setPixelColor( 2*x,     2*y+1,  rgb_temp );
    image_3.setPixelColor( 2*x+1,   2*y,    rgb_temp );
    image_3.setPixelColor( 2*x+1,   2*y+1,  rgb_temp );
}

void MainWindow::get_image_from_point( int x, int y )
{
    rgb_real = pixmap_1.toImage().pixelColor( x, y);   //get color from ( x; y ) position
    rgb_current.setRgb( rgb_real.red(), rgb_real.green(), rgb_real.blue() );
    draw_cursor( x, y );
    ui->statusBar->setStyleSheet(style_statusBar.arg(rgb_current.red()).arg(rgb_current.green()).arg(rgb_current.blue()));
}

void MainWindow::draw_cursor( int x, int y )
{
    scene->addEllipse( x, y, 1, 1, outlinePen_cursor);     //print cursors on QGraphicsView_2 (red point)
}




void MainWindow::start(){

    pixmap_1 = QPixmap::grabWindow(viewfinder->winId(), 0, 0, -1, -1);   //copy window from ViewFinder to img variable

    scene->addPixmap(pixmap_1);  //add img to scene


    scene_3->clear();
    scene_3->clearSelection();
    pixmap_3 = QPixmap::fromImage(image_3);
    scene_3->addPixmap(pixmap_3);

    mouse_curosr_position = ui->graphicsView->mapFromGlobal(QCursor::pos());        //get mouse cursor position
    ( ui->point_frame->isChecked() ) ? get_image_from_point( mouse_curosr_position.x(), mouse_curosr_position.y() ) : get_image_from_frame( x1, y1, x2, y2 );
    send_to_array( rgb_current );
    draw_char( red_array, green_array, blue_array );



    if ( ui->detect_object->isChecked() and ui->real_filtr->isChecked() ) scene_3->addRect(2*xmin, 2*ymin, 2*(xmax-xmin), 2*(ymax-ymin), outlinePen_red);   //detect object frame

}



void MainWindow::RGB_from_point(){
    QPoint p = ui->graphicsView->mapFromGlobal(QCursor::pos()); //get mouse cursor position
    rgbvalue = pixmap_1.toImage().pixelColor( p.x(), p.y());    //get color from cursor position
    red_array[array_size-1] = rgbvalue.red();
    green_array[array_size-1] = rgbvalue.green();
    blue_array[array_size-1] = rgbvalue.blue();

    scene->addLine( p.x(), p.y(), p.x(), p.y(), outlinePen_cursor);
    qDebug() << (QString("X: %1, Y: %2").arg(p.x()).arg(p.y()));
}

void MainWindow::on_clear_memory_clicked()
{
    for (int x = 0; x < array_size-1; x++ ){
       red_array[x] = 0;
       green_array[x] = 0;
       blue_array[x] = 0;
     }
}

void MainWindow::on_spinBox_valueChanged(int arg1)
{
    scale = arg1;
}

void MainWindow::on_start_stop_clicked(bool checked)
{
    if (checked){
        ui->groupBox_2->setEnabled( true );
        //co 200ms bedzie wywolywana funkcja start()
        timer1 = new QTimer(this);
        connect(timer1, SIGNAL(timeout()), this, SLOT(start()));
        timer1->start(200);
    }else{
         timer1->blockSignals(true);
         ui->groupBox_2->setEnabled( false );
    }

}





void MainWindow::on_correction_red_valueChanged(int arg1)
{
    correction_red = arg1;
}

void MainWindow::on_correction_green_valueChanged(int arg1)
{
    correction_green = arg1;
}

void MainWindow::on_correction_blue_valueChanged(int arg1)
{
    correction_blue = arg1;
}








void MainWindow::on_set_y2_valueChanged(int arg1)
{
    y2 = arg1;
}

void MainWindow::on_set_x2_valueChanged(int arg1)
{
    x2 = arg1;
}

void MainWindow::on_set_y1_valueChanged(int arg1)
{
    y1 = arg1;
}

void MainWindow::on_set_x1_valueChanged(int arg1)
{
    x1 = arg1;
}

void MainWindow::on_correction_brightness_valueChanged(int arg1)
{
    correction_brightness = arg1;
}

void MainWindow::on_pushButton_2_clicked()
{
    scene_4->clear();
    scene_4 ->clearSelection();
    scene_4->addLine( 0, 0, 64, 0, outlinePen_black );
    scene_4->addLine( 0, 64, 64, 64, outlinePen_black );
    for (int i = 0; i<256; i++ ){
        scene_4->addLine( i/4, (255-LUT[i])/4, i/4,(255-LUT[i])/4, outlinePen_red  );
    }
}





void MainWindow::on_pushButton_clicked()
{
    for ( int i = 0; i<256; i++){
        LUT[ i ] = 0;
    }
    scene_4->clear();
}




void MainWindow::on_connect_tcp_clicked()
{
    tcp_connect ? disconnected() : doConnect();

    tcp_connect ? ui->connect_tcp->setChecked( true ) : ui->connect_tcp->setChecked( false );


    if (tcp_connect and detected_gesture > 0){
        //co 100ms bedzie wywolywana funkcja send_tcp_value()
        timer2 = new QTimer(this);
        connect(timer2, SIGNAL(timeout()), this, SLOT(send_tcp_value()));
        timer2->start(100);
    }else{
         timer2->blockSignals(true);
    }
}




